#region Copyright Syncfusion Inc. 2001 -2005
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
//  Copyright Syncfusion Inc. All rights reserved. Use of this code is subject to the terms of our 
//  license. A copy of the current license can be obtained at any time by e-mailing licensing@syncfusion.com. 
//  Re-distribution in any form is strictly prohibited. Any infringement will be prosecuted under applicable laws. 
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
#endregion 
 
////////////////////////////////////////////////////////////////////////////////
//  Copyright Syncfusion Inc. 2003 - 2005. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Re-distribution in any form is strictly
//  prohibited. Any infringement will be prosecuted under applicable laws. 
//
//  Essential Diagram
//     Author:  Jeff Boenig
//     Created: March 2003
////////////////////////////////////////////////////////////////////////////////

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.IO;
using System.Reflection;
using System.Diagnostics;

using Syncfusion.Scripting;
using Syncfusion.Scripting.Design;
using Syncfusion.Windows.Forms.Diagram;

namespace Syncfusion.Windows.Forms.Diagram.Samples.DiagramTool
{
	/// <summary>
	/// Summary description for DiagramForm.
	/// </summary>
	public class DiagramForm : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Diagram.Controls.Diagram diagramComponent;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ChildFrameBarManager childFrameBarManager;
		private System.Windows.Forms.ImageList smBarItemImages;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemSelect;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemLine;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemRectangle;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemEllipse;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemText;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemPolyline;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemPolygon;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemArc;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemCurve;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemClosedCurve;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemImage;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemGroup;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemUngroup;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemBringToFront;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemSendToBack;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemBringForward;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemSendBackward;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemNudgeUp;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemNudgeDown;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemNudgeLeft;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemNudgeRight;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemRotate;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemRotateLeft;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemRotateRight;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemFlipVertical;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemFlipHorizontal;
		private Syncfusion.Windows.Forms.Tools.XPMenus.Bar barDrawing;
		private Syncfusion.Windows.Forms.Tools.XPMenus.Bar barNode;
		private Syncfusion.Windows.Forms.Tools.XPMenus.Bar barNudge;
		private Syncfusion.Windows.Forms.Tools.XPMenus.Bar barRotate;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemPan;
		private Syncfusion.Windows.Forms.Tools.XPMenus.Bar bar1;
		private System.ComponentModel.IContainer components;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemShowGrid;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemSnapToGrid;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemZoom;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ComboBoxBarItem comboBoxBarItemMagnification;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemOrthogonalLink;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemEditVertices;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemLink;
		private Syncfusion.Windows.Forms.Tools.XPMenus.Bar barLinks;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemDirectedLink;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemArcLink;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemRichText;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemRoundRect;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemBoldText;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemAlignTextLeft;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemCenterText;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemAlignTextRight;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ComboBoxBarItem comboBoxBarItemFontFamily;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ComboBoxBarItem comboBoxBarItemPointSize;
		private Syncfusion.Windows.Forms.Tools.XPMenus.Bar bar2;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemItalicText;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemUnderlineText;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemTextColor;
		private Syncfusion.Windows.Forms.Tools.XPMenus.Bar bar3;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemLoadScript;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemRunScript;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemEditScript;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemStopScript;
		private string fileName = null;

		public DiagramForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			this.diagramComponent.Model.Modified = false;

			//
			// Wire up event handlers to canvas
			//
			this.diagramComponent.Controller.ToolActivate += new Controller.ToolEventHandler(this.OnDiagramToolActivate);
			this.diagramComponent.Controller.ToolDeactivate += new Controller.ToolEventHandler(this.OnDiagramToolDeactivate);
			this.diagramComponent.Controller.SelectionChanged += new NodeCollectionEventHandler(OnSelectionChanged);

			// Load up names of fonts that can be selected
			this.LoadFontSelections();	
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
				this.diagramComponent.Controller.ToolActivate -= new Controller.ToolEventHandler(this.OnDiagramToolActivate);
				this.diagramComponent.Controller.ToolDeactivate -= new Controller.ToolEventHandler(this.OnDiagramToolDeactivate);
				this.diagramComponent.Controller.SelectionChanged -= new NodeCollectionEventHandler(OnSelectionChanged);
			}
			base.Dispose( disposing );
		}

		public Syncfusion.Windows.Forms.Diagram.Controls.Diagram Diagram
		{
			get
			{
				return this.diagramComponent;
			}
		}

		public void OpenFile(string fileName)
		{
			FileStream iStream = new FileStream(fileName, FileMode.Open);
			if (iStream != null)
			{
				this.diagramComponent.LoadBinary(iStream);
				iStream.Close();
				this.FileName = fileName;
			}
		}

		public void SaveFile()
		{
			if (!this.HasFileName)
			{
				throw new InvalidOperationException();
			}

			this.SaveAsFile(this.fileName);
		}

		public void SaveAsFile(string fileName)
		{
			FileStream oStream = null;
			
			try
			{
				oStream = new FileStream(fileName, FileMode.Create);
			}
			catch (Exception ex)
			{
				oStream = null;  // just to be sure
				MessageBox.Show("Error opening " + fileName + " - " + ex.Message);
			}

			if (oStream != null)
			{
				try
				{
					this.diagramComponent.SaveBinary(oStream);
					this.FileName = fileName;
				}
				catch (Exception ex)
				{
					MessageBox.Show("Serialization error - " + ex.Message);
				}
				finally
				{
					oStream.Close();
				}
			}
		}

		public string FileName
		{
			get
			{
				return this.fileName;
			}
			set
			{
				this.fileName = value;
				this.Text = System.IO.Path.GetFileNameWithoutExtension(this.fileName);
			}
		}

		public bool HasFileName
		{
			get
			{
				return (this.fileName != null && this.fileName.Length > 0);
			}
		}

		protected Syncfusion.Windows.Forms.Diagram.Controls.PropertyEditor PropertyEditor
		{
			get
			{
				if (this.MdiParent != null)
				{
					MainForm mainForm = this.MdiParent as MainForm;
					if (mainForm != null)
					{
						return mainForm.PropertyEditor;
					}
				}
				return null;
			}
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(DiagramForm));
			this.diagramComponent = new Syncfusion.Windows.Forms.Diagram.Controls.Diagram();
			this.childFrameBarManager = new Syncfusion.Windows.Forms.Tools.XPMenus.ChildFrameBarManager(this.components, this);
			this.barDrawing = new Syncfusion.Windows.Forms.Tools.XPMenus.Bar(this.childFrameBarManager, "Drawing");
			this.barItemSelect = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.smBarItemImages = new System.Windows.Forms.ImageList(this.components);
			this.barItemLine = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemPolyline = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemRectangle = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemRoundRect = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemEllipse = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemPolygon = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemCurve = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemClosedCurve = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemArc = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemText = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemRichText = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemImage = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemEditVertices = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barNode = new Syncfusion.Windows.Forms.Tools.XPMenus.Bar(this.childFrameBarManager, "Node");
			this.barItemGroup = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemUngroup = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemBringToFront = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemSendToBack = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemBringForward = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemSendBackward = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barNudge = new Syncfusion.Windows.Forms.Tools.XPMenus.Bar(this.childFrameBarManager, "Nudge");
			this.barItemNudgeUp = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemNudgeDown = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemNudgeLeft = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemNudgeRight = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barLinks = new Syncfusion.Windows.Forms.Tools.XPMenus.Bar(this.childFrameBarManager, "Links");
			this.barItemLink = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemOrthogonalLink = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemDirectedLink = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemArcLink = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barRotate = new Syncfusion.Windows.Forms.Tools.XPMenus.Bar(this.childFrameBarManager, "Rotate");
			this.barItemRotate = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemRotateLeft = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemRotateRight = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemFlipVertical = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemFlipHorizontal = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.bar1 = new Syncfusion.Windows.Forms.Tools.XPMenus.Bar(this.childFrameBarManager, "View");
			this.barItemPan = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemShowGrid = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemSnapToGrid = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemZoom = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.comboBoxBarItemMagnification = new Syncfusion.Windows.Forms.Tools.XPMenus.ComboBoxBarItem();
			this.bar2 = new Syncfusion.Windows.Forms.Tools.XPMenus.Bar(this.childFrameBarManager, "Text Formatting");
			this.comboBoxBarItemFontFamily = new Syncfusion.Windows.Forms.Tools.XPMenus.ComboBoxBarItem();
			this.comboBoxBarItemPointSize = new Syncfusion.Windows.Forms.Tools.XPMenus.ComboBoxBarItem();
			this.barItemBoldText = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemItalicText = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemUnderlineText = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemAlignTextLeft = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemCenterText = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemAlignTextRight = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemTextColor = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.bar3 = new Syncfusion.Windows.Forms.Tools.XPMenus.Bar(this.childFrameBarManager, "Scripting");
			this.barItemLoadScript = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemRunScript = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemEditScript = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemStopScript = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			((System.ComponentModel.ISupportInitialize)(this.diagramComponent.Model)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.childFrameBarManager)).BeginInit();
			this.SuspendLayout();
			// 
			// diagramComponent
			// 
			this.diagramComponent.AllowDrop = true;
			// 
			// diagramComponent.Controller
			// 
			this.diagramComponent.Controller.MaxHistory = 256;
			this.diagramComponent.Dock = System.Windows.Forms.DockStyle.Fill;
			this.diagramComponent.HScroll = true;
			this.diagramComponent.LayoutManager = null;
			this.diagramComponent.LineRouter = null;
			this.diagramComponent.Location = new System.Drawing.Point(0, 0);
			// 
			// diagramComponent.Model
			// 
			this.diagramComponent.Model.BackgroundStyle.Color = System.Drawing.Color.White;
			this.diagramComponent.Model.BackgroundStyle.GradientAngle = 90F;
			this.diagramComponent.Model.BackgroundStyle.GradientBounds = ((System.Drawing.RectangleF)(resources.GetObject("diagramComponent.Model.BackgroundStyle.GradientBounds")));
			this.diagramComponent.Model.BackgroundStyle.GradientStartColor = System.Drawing.Color.White;
			this.diagramComponent.Model.BackgroundStyle.Properties = this.diagramComponent.Model;
			this.diagramComponent.Model.BackgroundStyle.Texture = null;
			this.diagramComponent.Model.BackgroundStyle.TextureWrapMode = System.Drawing.Drawing2D.WrapMode.Tile;
			this.diagramComponent.Model.BackgroundStyle.Type = Syncfusion.Windows.Forms.Diagram.BackgroundStyle.BackgroundType.Solid;
			this.diagramComponent.Model.BoundaryConstraintsEnabled = true;
			this.diagramComponent.Model.FillStyle.AlphaFactor = 255;
			this.diagramComponent.Model.FillStyle.Color = System.Drawing.Color.LightGray;
			this.diagramComponent.Model.FillStyle.GradientAngle = 90F;
			this.diagramComponent.Model.FillStyle.GradientBounds = ((System.Drawing.RectangleF)(resources.GetObject("diagramComponent.Model.FillStyle.GradientBounds")));
			this.diagramComponent.Model.FillStyle.GradientStartColor = System.Drawing.Color.LightGray;
			this.diagramComponent.Model.FillStyle.Properties = this.diagramComponent.Model;
			this.diagramComponent.Model.FillStyle.Texture = null;
			this.diagramComponent.Model.FillStyle.TextureWrapMode = System.Drawing.Drawing2D.WrapMode.Tile;
			this.diagramComponent.Model.FillStyle.Type = Syncfusion.Windows.Forms.Diagram.FillStyle.FillType.Solid;
			this.diagramComponent.Model.Height = 1024F;
			this.diagramComponent.Model.LineStyle.DashCap = System.Drawing.Drawing2D.DashCap.Flat;
			this.diagramComponent.Model.LineStyle.DashOffset = 0F;
			this.diagramComponent.Model.LineStyle.DashStyle = System.Drawing.Drawing2D.DashStyle.Solid;
			this.diagramComponent.Model.LineStyle.EndCap = System.Drawing.Drawing2D.LineCap.Flat;
			this.diagramComponent.Model.LineStyle.LineColor = System.Drawing.Color.Black;
			this.diagramComponent.Model.LineStyle.LineJoin = System.Drawing.Drawing2D.LineJoin.Bevel;
			this.diagramComponent.Model.LineStyle.LineWidth = 2F;
			this.diagramComponent.Model.LineStyle.MiterLimit = 10F;
			this.diagramComponent.Model.LineStyle.Properties = this.diagramComponent.Model;
			this.diagramComponent.Model.MeasurementScale = 1F;
			this.diagramComponent.Model.MeasurementUnits = System.Drawing.GraphicsUnit.Pixel;
			this.diagramComponent.Model.Name = "Model";
			this.diagramComponent.Model.RenderingStyle.Properties = this.diagramComponent.Model;
			this.diagramComponent.Model.RenderingStyle.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighQuality;
			this.diagramComponent.Model.ShadowStyle.AlphaFactor = 128;
			this.diagramComponent.Model.ShadowStyle.Color = System.Drawing.Color.LightGray;
			this.diagramComponent.Model.ShadowStyle.OffsetX = 6F;
			this.diagramComponent.Model.ShadowStyle.OffsetY = 6F;
			this.diagramComponent.Model.ShadowStyle.Properties = this.diagramComponent.Model;
			this.diagramComponent.Model.ShadowStyle.Visible = false;
			this.diagramComponent.Model.Width = 860F;
			this.diagramComponent.Name = "diagramComponent";
			this.diagramComponent.NudgeIncrement = 1F;
			this.diagramComponent.ScrollGranularity = 0.5F;
			this.diagramComponent.Size = new System.Drawing.Size(520, 406);
			this.diagramComponent.SmartSizeBox = false;
			this.diagramComponent.TabIndex = 0;
			this.diagramComponent.Tag = "";
			// 
			// diagramComponent.View
			// 
			this.diagramComponent.View.BackgroundColor = System.Drawing.Color.SteelBlue;
			this.diagramComponent.View.Grid.Color = System.Drawing.Color.LightBlue;
			this.diagramComponent.View.Grid.DashOffset = 4F;
			this.diagramComponent.View.Grid.DashStyle = System.Drawing.Drawing2D.DashStyle.Dash;
			this.diagramComponent.View.Grid.GridStyle = Syncfusion.Windows.Forms.Diagram.GridStyle.Line;
			this.diagramComponent.View.Grid.HorizontalSpacing = 15F;
			this.diagramComponent.View.Grid.SnapToGrid = false;
			this.diagramComponent.View.Grid.VerticalSpacing = 15F;
			this.diagramComponent.View.Grid.Visible = true;
			this.diagramComponent.View.HandleAnchorColor = System.Drawing.Color.LightGray;
			this.diagramComponent.View.HandleColor = System.Drawing.Color.White;
			this.diagramComponent.View.HandleDisabledColor = System.Drawing.Color.Black;
			this.diagramComponent.View.HandleSize = 6;
			this.diagramComponent.View.HorizontalRuler.Visible = true;
			this.diagramComponent.View.MouseTrackingEnabled = true;
			this.diagramComponent.View.PasteOffsetX = 10;
			this.diagramComponent.View.PasteOffsetY = 10;
			this.diagramComponent.View.RulerFillColor = System.Drawing.Color.LightGray;
			this.diagramComponent.View.RulerLineColor = System.Drawing.Color.Black;
			this.diagramComponent.View.RulerSize = 16;
			this.diagramComponent.View.RulerUnits = Syncfusion.Windows.Forms.Diagram.MeasurementsUnit.Inches;
			this.diagramComponent.View.ShowPageBounds = true;
			this.diagramComponent.View.VerticalRuler.Visible = true;
			this.diagramComponent.View.MagnificationChanged += new Syncfusion.Windows.Forms.Diagram.ViewMagnificationEventHandler(this.diagramComponent_View_MagnificationChanged);
			this.diagramComponent.VScroll = true;
			this.diagramComponent.CompileError += new Syncfusion.Scripting.VsaErrorEventHandler(this.diagramComponent_CompileError);
			// 
			// childFrameBarManager
			// 
			this.childFrameBarManager.BarPositionInfo = ((System.IO.MemoryStream)(resources.GetObject("childFrameBarManager.BarPositionInfo")));
			this.childFrameBarManager.Bars.Add(this.barDrawing);
			this.childFrameBarManager.Bars.Add(this.barNode);
			this.childFrameBarManager.Bars.Add(this.barNudge);
			this.childFrameBarManager.Bars.Add(this.barLinks);
			this.childFrameBarManager.Bars.Add(this.barRotate);
			this.childFrameBarManager.Bars.Add(this.bar1);
			this.childFrameBarManager.Bars.Add(this.bar2);
			this.childFrameBarManager.Bars.Add(this.bar3);
			this.childFrameBarManager.Categories.Add("Drawing Tools");
			this.childFrameBarManager.Categories.Add("Node Tools");
			this.childFrameBarManager.Categories.Add("Connection Tools");
			this.childFrameBarManager.Categories.Add("Nudge Tools");
			this.childFrameBarManager.Categories.Add("Rotate Tools");
			this.childFrameBarManager.Categories.Add("View Tools");
			this.childFrameBarManager.Categories.Add("Text Formatting");
			this.childFrameBarManager.Categories.Add("Scripting");
			this.childFrameBarManager.CurrentBaseFormType = "System.Windows.Forms.Form";
			this.childFrameBarManager.Form = this;
			this.childFrameBarManager.ImageList = null;
			this.childFrameBarManager.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																											  this.barItemSelect,
																											  this.barItemLine,
																											  this.barItemRectangle,
																											  this.barItemEllipse,
																											  this.barItemText,
																											  this.barItemPolyline,
																											  this.barItemPolygon,
																											  this.barItemArc,
																											  this.barItemCurve,
																											  this.barItemClosedCurve,
																											  this.barItemImage,
																											  this.barItemGroup,
																											  this.barItemUngroup,
																											  this.barItemBringToFront,
																											  this.barItemSendToBack,
																											  this.barItemBringForward,
																											  this.barItemSendBackward,
																											  this.barItemLink,
																											  this.barItemNudgeUp,
																											  this.barItemNudgeDown,
																											  this.barItemNudgeLeft,
																											  this.barItemNudgeRight,
																											  this.barItemRotate,
																											  this.barItemRotateLeft,
																											  this.barItemRotateRight,
																											  this.barItemFlipVertical,
																											  this.barItemFlipHorizontal,
																											  this.barItemPan,
																											  this.barItemShowGrid,
																											  this.barItemSnapToGrid,
																											  this.barItemZoom,
																											  this.comboBoxBarItemMagnification,
																											  this.barItemOrthogonalLink,
																											  this.barItemEditVertices,
																											  this.barItemDirectedLink,
																											  this.barItemArcLink,
																											  this.barItemRichText,
																											  this.barItemRoundRect,
																											  this.barItemBoldText,
																											  this.barItemItalicText,
																											  this.barItemUnderlineText,
																											  this.barItemAlignTextLeft,
																											  this.barItemCenterText,
																											  this.barItemAlignTextRight,
																											  this.comboBoxBarItemFontFamily,
																											  this.comboBoxBarItemPointSize,
																											  this.barItemTextColor,
																											  this.barItemLoadScript,
																											  this.barItemRunScript,
																											  this.barItemEditScript,
																											  this.barItemStopScript});
			this.childFrameBarManager.LargeImageList = null;
			this.childFrameBarManager.Style = Syncfusion.Windows.Forms.VisualStyle.Office2003;
			// 
			// barDrawing
			// 
			this.barDrawing.BarName = "Drawing";
			this.barDrawing.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																									this.barItemSelect,
																									this.barItemLine,
																									this.barItemPolyline,
																									this.barItemRectangle,
																									this.barItemRoundRect,
																									this.barItemEllipse,
																									this.barItemPolygon,
																									this.barItemCurve,
																									this.barItemClosedCurve,
																									this.barItemArc,
																									this.barItemText,
																									this.barItemRichText,
																									this.barItemImage,
																									this.barItemEditVertices});
			this.barDrawing.Manager = this.childFrameBarManager;
			// 
			// barItemSelect
			// 
			this.barItemSelect.CategoryIndex = 0;
			this.barItemSelect.ID = "Pointer";
			this.barItemSelect.ImageIndex = 0;
			this.barItemSelect.ImageList = this.smBarItemImages;
			this.barItemSelect.Tag = "SelectTool";
			this.barItemSelect.Text = "Select";
			this.barItemSelect.Tooltip = "Select";
			this.barItemSelect.Click += new System.EventHandler(this.toolActivate);
			// 
			// smBarItemImages
			// 
			this.smBarItemImages.ImageSize = new System.Drawing.Size(16, 16);
			this.smBarItemImages.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("smBarItemImages.ImageStream")));
			this.smBarItemImages.TransparentColor = System.Drawing.Color.Fuchsia;
			// 
			// barItemLine
			// 
			this.barItemLine.CategoryIndex = 0;
			this.barItemLine.ID = "Line";
			this.barItemLine.ImageIndex = 1;
			this.barItemLine.ImageList = this.smBarItemImages;
			this.barItemLine.Tag = "LineTool";
			this.barItemLine.Text = "Line";
			this.barItemLine.Tooltip = "Line";
			this.barItemLine.Click += new System.EventHandler(this.toolActivate);
			// 
			// barItemPolyline
			// 
			this.barItemPolyline.CategoryIndex = 0;
			this.barItemPolyline.ID = "Polyline";
			this.barItemPolyline.ImageIndex = 2;
			this.barItemPolyline.ImageList = this.smBarItemImages;
			this.barItemPolyline.Tag = "PolyLineTool";
			this.barItemPolyline.Text = "Polyline";
			this.barItemPolyline.Tooltip = "Polyline";
			this.barItemPolyline.Click += new System.EventHandler(this.toolActivate);
			// 
			// barItemRectangle
			// 
			this.barItemRectangle.CategoryIndex = 0;
			this.barItemRectangle.ID = "Rectangle";
			this.barItemRectangle.ImageIndex = 4;
			this.barItemRectangle.ImageList = this.smBarItemImages;
			this.barItemRectangle.Tag = "RectangleTool";
			this.barItemRectangle.Text = "Rectangle";
			this.barItemRectangle.Tooltip = "Rectangle";
			this.barItemRectangle.Click += new System.EventHandler(this.toolActivate);
			// 
			// barItemRoundRect
			// 
			this.barItemRoundRect.CategoryIndex = 0;
			this.barItemRoundRect.ID = "Rounded Rectangle";
			this.barItemRoundRect.ImageIndex = 5;
			this.barItemRoundRect.ImageList = this.smBarItemImages;
			this.barItemRoundRect.Tag = "RoundRectTool";
			this.barItemRoundRect.Text = "Rounded Rectangle";
			this.barItemRoundRect.Click += new System.EventHandler(this.toolActivate);
			// 
			// barItemEllipse
			// 
			this.barItemEllipse.CategoryIndex = 0;
			this.barItemEllipse.ID = "Ellipse";
			this.barItemEllipse.ImageIndex = 7;
			this.barItemEllipse.ImageList = this.smBarItemImages;
			this.barItemEllipse.Tag = "EllipseTool";
			this.barItemEllipse.Text = "Ellipse";
			this.barItemEllipse.Tooltip = "Ellipse";
			this.barItemEllipse.Click += new System.EventHandler(this.toolActivate);
			// 
			// barItemPolygon
			// 
			this.barItemPolygon.CategoryIndex = 0;
			this.barItemPolygon.ID = "Polygon";
			this.barItemPolygon.ImageIndex = 6;
			this.barItemPolygon.ImageList = this.smBarItemImages;
			this.barItemPolygon.Tag = "PolygonTool";
			this.barItemPolygon.Text = "Polygon";
			this.barItemPolygon.Tooltip = "Polygon";
			this.barItemPolygon.Click += new System.EventHandler(this.toolActivate);
			// 
			// barItemCurve
			// 
			this.barItemCurve.CategoryIndex = 0;
			this.barItemCurve.ID = "Curve";
			this.barItemCurve.ImageIndex = 9;
			this.barItemCurve.ImageList = this.smBarItemImages;
			this.barItemCurve.Tag = "CurveTool";
			this.barItemCurve.Text = "Curve";
			this.barItemCurve.Tooltip = "Curve";
			this.barItemCurve.Click += new System.EventHandler(this.toolActivate);
			// 
			// barItemClosedCurve
			// 
			this.barItemClosedCurve.CategoryIndex = 0;
			this.barItemClosedCurve.ID = "Closed Curve";
			this.barItemClosedCurve.ImageIndex = 10;
			this.barItemClosedCurve.ImageList = this.smBarItemImages;
			this.barItemClosedCurve.Tag = "ClosedCurveTool";
			this.barItemClosedCurve.Text = "Closed Curve";
			this.barItemClosedCurve.Tooltip = "Closed Curve";
			this.barItemClosedCurve.Click += new System.EventHandler(this.toolActivate);
			// 
			// barItemArc
			// 
			this.barItemArc.CategoryIndex = 0;
			this.barItemArc.ID = "Arc";
			this.barItemArc.ImageIndex = 8;
			this.barItemArc.ImageList = this.smBarItemImages;
			this.barItemArc.Tag = "ArcTool";
			this.barItemArc.Text = "Arc";
			this.barItemArc.Tooltip = "Arc";
			this.barItemArc.Click += new System.EventHandler(this.toolActivate);
			// 
			// barItemText
			// 
			this.barItemText.CategoryIndex = 0;
			this.barItemText.ID = "Text";
			this.barItemText.ImageIndex = 12;
			this.barItemText.ImageList = this.smBarItemImages;
			this.barItemText.Tag = "TextTool";
			this.barItemText.Text = "Text";
			this.barItemText.Tooltip = "Text";
			this.barItemText.Click += new System.EventHandler(this.toolActivate);
			// 
			// barItemRichText
			// 
			this.barItemRichText.CategoryIndex = 0;
			this.barItemRichText.ID = "Rich Text";
			this.barItemRichText.ImageIndex = 48;
			this.barItemRichText.ImageList = this.smBarItemImages;
			this.barItemRichText.Tag = "RichTextTool";
			this.barItemRichText.Text = "Rich Text";
			this.barItemRichText.Tooltip = "Rich Text";
			this.barItemRichText.Click += new System.EventHandler(this.toolActivate);
			// 
			// barItemImage
			// 
			this.barItemImage.CategoryIndex = 0;
			this.barItemImage.ID = "Image";
			this.barItemImage.ImageIndex = 11;
			this.barItemImage.ImageList = this.smBarItemImages;
			this.barItemImage.Tag = "ImageTool";
			this.barItemImage.Text = "Image";
			this.barItemImage.Tooltip = "Image";
			this.barItemImage.Click += new System.EventHandler(this.barItemImage_Click);
			// 
			// barItemEditVertices
			// 
			this.barItemEditVertices.CategoryIndex = 0;
			this.barItemEditVertices.ID = "Edit Vertices";
			this.barItemEditVertices.ImageIndex = 13;
			this.barItemEditVertices.ImageList = this.smBarItemImages;
			this.barItemEditVertices.Tag = "VertexEditTool";
			this.barItemEditVertices.Text = "Edit Vertices";
			this.barItemEditVertices.Click += new System.EventHandler(this.toolActivate);
			// 
			// barNode
			// 
			this.barNode.BarName = "Node";
			this.barNode.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																								 this.barItemGroup,
																								 this.barItemUngroup,
																								 this.barItemBringToFront,
																								 this.barItemSendToBack,
																								 this.barItemBringForward,
																								 this.barItemSendBackward});
			this.barNode.Manager = this.childFrameBarManager;
			// 
			// barItemGroup
			// 
			this.barItemGroup.CategoryIndex = 1;
			this.barItemGroup.ID = "Group";
			this.barItemGroup.ImageIndex = 14;
			this.barItemGroup.ImageList = this.smBarItemImages;
			this.barItemGroup.Tag = "GroupTool";
			this.barItemGroup.Text = "Group";
			this.barItemGroup.Tooltip = "Group";
			this.barItemGroup.Click += new System.EventHandler(this.toolActivate);
			// 
			// barItemUngroup
			// 
			this.barItemUngroup.CategoryIndex = 1;
			this.barItemUngroup.ID = "Ungroup";
			this.barItemUngroup.ImageIndex = 15;
			this.barItemUngroup.ImageList = this.smBarItemImages;
			this.barItemUngroup.Tag = "UngroupTool";
			this.barItemUngroup.Text = "Ungroup";
			this.barItemUngroup.Tooltip = "Ungroup";
			this.barItemUngroup.Click += new System.EventHandler(this.toolActivate);
			// 
			// barItemBringToFront
			// 
			this.barItemBringToFront.CategoryIndex = 1;
			this.barItemBringToFront.ID = "Bring To Front";
			this.barItemBringToFront.ImageIndex = 41;
			this.barItemBringToFront.ImageList = this.smBarItemImages;
			this.barItemBringToFront.Text = "Bring To Front";
			this.barItemBringToFront.Tooltip = "Bring To Front";
			this.barItemBringToFront.Click += new System.EventHandler(this.barItemBringToFront_Click);
			// 
			// barItemSendToBack
			// 
			this.barItemSendToBack.CategoryIndex = 1;
			this.barItemSendToBack.ID = "Send To Back";
			this.barItemSendToBack.ImageIndex = 43;
			this.barItemSendToBack.ImageList = this.smBarItemImages;
			this.barItemSendToBack.Text = "Send To Back";
			this.barItemSendToBack.Click += new System.EventHandler(this.barItemSendToBack_Click);
			// 
			// barItemBringForward
			// 
			this.barItemBringForward.CategoryIndex = 1;
			this.barItemBringForward.ID = "Bring Forward";
			this.barItemBringForward.ImageIndex = 40;
			this.barItemBringForward.ImageList = this.smBarItemImages;
			this.barItemBringForward.Text = "Bring Forward";
			this.barItemBringForward.Click += new System.EventHandler(this.barItemBringForward_Click);
			// 
			// barItemSendBackward
			// 
			this.barItemSendBackward.CategoryIndex = 1;
			this.barItemSendBackward.ID = "Send Backward";
			this.barItemSendBackward.ImageIndex = 42;
			this.barItemSendBackward.ImageList = this.smBarItemImages;
			this.barItemSendBackward.Text = "Send Backward";
			this.barItemSendBackward.Click += new System.EventHandler(this.barItemSendBackward_Click);
			// 
			// barNudge
			// 
			this.barNudge.BarName = "Nudge";
			this.barNudge.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																								  this.barItemNudgeUp,
																								  this.barItemNudgeDown,
																								  this.barItemNudgeLeft,
																								  this.barItemNudgeRight});
			this.barNudge.Manager = this.childFrameBarManager;
			// 
			// barItemNudgeUp
			// 
			this.barItemNudgeUp.CategoryIndex = 3;
			this.barItemNudgeUp.ID = "Nudge Up";
			this.barItemNudgeUp.ImageIndex = 22;
			this.barItemNudgeUp.ImageList = this.smBarItemImages;
			this.barItemNudgeUp.Text = "Nudge Up";
			this.barItemNudgeUp.Tooltip = "Nudge Up";
			this.barItemNudgeUp.Click += new System.EventHandler(this.barItemNudgeUp_Click);
			// 
			// barItemNudgeDown
			// 
			this.barItemNudgeDown.CategoryIndex = 3;
			this.barItemNudgeDown.ID = "Nudge Down";
			this.barItemNudgeDown.ImageIndex = 23;
			this.barItemNudgeDown.ImageList = this.smBarItemImages;
			this.barItemNudgeDown.Text = "Nudge Down";
			this.barItemNudgeDown.Tooltip = "Nudge Down";
			this.barItemNudgeDown.Click += new System.EventHandler(this.barItemNudgeDown_Click);
			// 
			// barItemNudgeLeft
			// 
			this.barItemNudgeLeft.CategoryIndex = 3;
			this.barItemNudgeLeft.ID = "Nudge Left";
			this.barItemNudgeLeft.ImageIndex = 20;
			this.barItemNudgeLeft.ImageList = this.smBarItemImages;
			this.barItemNudgeLeft.Text = "Nudge Left";
			this.barItemNudgeLeft.Tooltip = "Nudge Left";
			this.barItemNudgeLeft.Click += new System.EventHandler(this.barItemNudgeLeft_Click);
			// 
			// barItemNudgeRight
			// 
			this.barItemNudgeRight.CategoryIndex = 3;
			this.barItemNudgeRight.ID = "Nudge Right";
			this.barItemNudgeRight.ImageIndex = 21;
			this.barItemNudgeRight.ImageList = this.smBarItemImages;
			this.barItemNudgeRight.Text = "Nudge Right";
			this.barItemNudgeRight.Tooltip = "Nudge Right";
			this.barItemNudgeRight.Click += new System.EventHandler(this.barItemNudgeRight_Click);
			// 
			// barLinks
			// 
			this.barLinks.BarName = "Links";
			this.barLinks.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																								  this.barItemLink,
																								  this.barItemOrthogonalLink,
																								  this.barItemDirectedLink,
																								  this.barItemArcLink});
			this.barLinks.Manager = this.childFrameBarManager;
			// 
			// barItemLink
			// 
			this.barItemLink.CategoryIndex = 2;
			this.barItemLink.ID = "Link";
			this.barItemLink.ImageIndex = 44;
			this.barItemLink.ImageList = this.smBarItemImages;
			this.barItemLink.Text = "Link";
			this.barItemLink.Tooltip = "Link";
			this.barItemLink.Click += new System.EventHandler(this.barItemLinkSymbols_Click);
			// 
			// barItemOrthogonalLink
			// 
			this.barItemOrthogonalLink.CategoryIndex = 2;
			this.barItemOrthogonalLink.ID = "Orthogonal Link";
			this.barItemOrthogonalLink.ImageIndex = 45;
			this.barItemOrthogonalLink.ImageList = this.smBarItemImages;
			this.barItemOrthogonalLink.Text = "Orthogonal Link";
			this.barItemOrthogonalLink.Click += new System.EventHandler(this.barItemOrthogonalLink_Click);
			// 
			// barItemDirectedLink
			// 
			this.barItemDirectedLink.CategoryIndex = 2;
			this.barItemDirectedLink.ID = "Directed Link";
			this.barItemDirectedLink.ImageIndex = 46;
			this.barItemDirectedLink.ImageList = this.smBarItemImages;
			this.barItemDirectedLink.Text = "Directed Link";
			this.barItemDirectedLink.Tooltip = "Directed Link";
			this.barItemDirectedLink.Click += new System.EventHandler(this.barItemDirectedLink_Click);
			// 
			// barItemArcLink
			// 
			this.barItemArcLink.CategoryIndex = 2;
			this.barItemArcLink.ID = "Arc Link";
			this.barItemArcLink.ImageIndex = 47;
			this.barItemArcLink.ImageList = this.smBarItemImages;
			this.barItemArcLink.Text = "Arc Link";
			this.barItemArcLink.Tooltip = "Arc Link";
			this.barItemArcLink.Click += new System.EventHandler(this.barItemArcLink_Click);
			// 
			// barRotate
			// 
			this.barRotate.BarName = "Rotate";
			this.barRotate.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																								   this.barItemRotate,
																								   this.barItemRotateLeft,
																								   this.barItemRotateRight,
																								   this.barItemFlipVertical,
																								   this.barItemFlipHorizontal});
			this.barRotate.Manager = this.childFrameBarManager;
			// 
			// barItemRotate
			// 
			this.barItemRotate.CategoryIndex = 4;
			this.barItemRotate.ID = "Rotate";
			this.barItemRotate.ImageIndex = 35;
			this.barItemRotate.ImageList = this.smBarItemImages;
			this.barItemRotate.Tag = "RotateTool";
			this.barItemRotate.Text = "Rotate";
			this.barItemRotate.Tooltip = "Rotate";
			this.barItemRotate.Click += new System.EventHandler(this.toolActivate);
			// 
			// barItemRotateLeft
			// 
			this.barItemRotateLeft.CategoryIndex = 4;
			this.barItemRotateLeft.ID = "Rotate Left";
			this.barItemRotateLeft.ImageIndex = 36;
			this.barItemRotateLeft.ImageList = this.smBarItemImages;
			this.barItemRotateLeft.Text = "Rotate Left";
			this.barItemRotateLeft.Tooltip = "Rotate Left";
			this.barItemRotateLeft.Click += new System.EventHandler(this.barItemRotateLeft_Click);
			// 
			// barItemRotateRight
			// 
			this.barItemRotateRight.CategoryIndex = 4;
			this.barItemRotateRight.ID = "Rotate Right";
			this.barItemRotateRight.ImageIndex = 37;
			this.barItemRotateRight.ImageList = this.smBarItemImages;
			this.barItemRotateRight.Text = "Rotate Right";
			this.barItemRotateRight.Tooltip = "Rotate Right";
			this.barItemRotateRight.Click += new System.EventHandler(this.barItemRotateRight_Click);
			// 
			// barItemFlipVertical
			// 
			this.barItemFlipVertical.CategoryIndex = 4;
			this.barItemFlipVertical.ID = "Flip Vertical";
			this.barItemFlipVertical.ImageIndex = 39;
			this.barItemFlipVertical.ImageList = this.smBarItemImages;
			this.barItemFlipVertical.Text = "Flip Vertical";
			this.barItemFlipVertical.Tooltip = "Flip Vertical";
			this.barItemFlipVertical.Click += new System.EventHandler(this.barItemFlipVertical_Click);
			// 
			// barItemFlipHorizontal
			// 
			this.barItemFlipHorizontal.CategoryIndex = 4;
			this.barItemFlipHorizontal.ID = "Flip Horizontal";
			this.barItemFlipHorizontal.ImageIndex = 38;
			this.barItemFlipHorizontal.ImageList = this.smBarItemImages;
			this.barItemFlipHorizontal.Text = "Flip Horizontal";
			this.barItemFlipHorizontal.Tooltip = "Flip Horizontal";
			this.barItemFlipHorizontal.Click += new System.EventHandler(this.barItemFlipHorizontal_Click);
			// 
			// bar1
			// 
			this.bar1.BarName = "View";
			this.bar1.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																							  this.barItemPan,
																							  this.barItemShowGrid,
																							  this.barItemSnapToGrid,
																							  this.barItemZoom,
																							  this.comboBoxBarItemMagnification});
			this.bar1.Manager = this.childFrameBarManager;
			// 
			// barItemPan
			// 
			this.barItemPan.CategoryIndex = 5;
			this.barItemPan.ID = "Pan";
			this.barItemPan.ImageIndex = 16;
			this.barItemPan.ImageList = this.smBarItemImages;
			this.barItemPan.Tag = "PanTool";
			this.barItemPan.Text = "Pan";
			this.barItemPan.Tooltip = "Pan";
			this.barItemPan.Click += new System.EventHandler(this.toolActivate);
			// 
			// barItemShowGrid
			// 
			this.barItemShowGrid.CategoryIndex = 5;
			this.barItemShowGrid.ID = "Show Grid";
			this.barItemShowGrid.ImageIndex = 18;
			this.barItemShowGrid.ImageList = this.smBarItemImages;
			this.barItemShowGrid.Text = "Show Grid";
			this.barItemShowGrid.Tooltip = "Show Grid";
			this.barItemShowGrid.Click += new System.EventHandler(this.barItemShowGrid_Click);
			// 
			// barItemSnapToGrid
			// 
			this.barItemSnapToGrid.CategoryIndex = 5;
			this.barItemSnapToGrid.ID = "Snap To Grid";
			this.barItemSnapToGrid.ImageIndex = 19;
			this.barItemSnapToGrid.ImageList = this.smBarItemImages;
			this.barItemSnapToGrid.Text = "Snap To Grid";
			this.barItemSnapToGrid.Click += new System.EventHandler(this.barItemSnapToGrid_Click);
			// 
			// barItemZoom
			// 
			this.barItemZoom.CategoryIndex = 5;
			this.barItemZoom.ID = "Zoom";
			this.barItemZoom.ImageIndex = 17;
			this.barItemZoom.ImageList = this.smBarItemImages;
			this.barItemZoom.Tag = "ZoomTool";
			this.barItemZoom.Text = "Zoom";
			this.barItemZoom.Tooltip = "Zoom";
			this.barItemZoom.Click += new System.EventHandler(this.toolActivate);
			// 
			// comboBoxBarItemMagnification
			// 
			this.comboBoxBarItemMagnification.CategoryIndex = 5;
			this.comboBoxBarItemMagnification.ChoiceList.AddRange(new string[] {
																				   "25%",
																				   "50%",
																				   "75%",
																				   "100%",
																				   "125%",
																				   "150%",
																				   "175%",
																				   "200%"});
			this.comboBoxBarItemMagnification.Editable = false;
			this.comboBoxBarItemMagnification.ID = "Magnification";
			this.comboBoxBarItemMagnification.Text = "Magnification";
			this.comboBoxBarItemMagnification.Tooltip = "Magnification";
			this.comboBoxBarItemMagnification.Click += new System.EventHandler(this.comboBoxBarItemMagnification_Click);
			// 
			// bar2
			// 
			this.bar2.BarName = "Text Formatting";
			this.bar2.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																							  this.comboBoxBarItemFontFamily,
																							  this.comboBoxBarItemPointSize,
																							  this.barItemBoldText,
																							  this.barItemItalicText,
																							  this.barItemUnderlineText,
																							  this.barItemAlignTextLeft,
																							  this.barItemCenterText,
																							  this.barItemAlignTextRight,
																							  this.barItemTextColor});
			this.bar2.Manager = this.childFrameBarManager;
			// 
			// comboBoxBarItemFontFamily
			// 
			this.comboBoxBarItemFontFamily.CategoryIndex = 6;
			this.comboBoxBarItemFontFamily.Editable = false;
			this.comboBoxBarItemFontFamily.ID = "Font Family";
			this.comboBoxBarItemFontFamily.MinWidth = 120;
			this.comboBoxBarItemFontFamily.Text = "Font Family";
			this.comboBoxBarItemFontFamily.Tooltip = "Font Family";
			// 
			// comboBoxBarItemPointSize
			// 
			this.comboBoxBarItemPointSize.CategoryIndex = 6;
			this.comboBoxBarItemPointSize.ID = "Point Size";
			this.comboBoxBarItemPointSize.Text = "Point Size";
			// 
			// barItemBoldText
			// 
			this.barItemBoldText.CategoryIndex = 6;
			this.barItemBoldText.ID = "Bold";
			this.barItemBoldText.ImageIndex = 49;
			this.barItemBoldText.ImageList = this.smBarItemImages;
			this.barItemBoldText.Text = "Bold";
			this.barItemBoldText.Tooltip = "Bold";
			this.barItemBoldText.Click += new System.EventHandler(this.barItemBoldText_Click);
			// 
			// barItemItalicText
			// 
			this.barItemItalicText.CategoryIndex = 6;
			this.barItemItalicText.ID = "Italic";
			this.barItemItalicText.ImageIndex = 50;
			this.barItemItalicText.ImageList = this.smBarItemImages;
			this.barItemItalicText.Text = "Italic";
			this.barItemItalicText.Tooltip = "Italic";
			this.barItemItalicText.Click += new System.EventHandler(this.barItemItalicText_Click);
			// 
			// barItemUnderlineText
			// 
			this.barItemUnderlineText.CategoryIndex = 6;
			this.barItemUnderlineText.ID = "Underline";
			this.barItemUnderlineText.ImageIndex = 51;
			this.barItemUnderlineText.ImageList = this.smBarItemImages;
			this.barItemUnderlineText.Text = "Underline";
			this.barItemUnderlineText.Tooltip = "Underline";
			this.barItemUnderlineText.Click += new System.EventHandler(this.barItemUnderlineText_Click);
			// 
			// barItemAlignTextLeft
			// 
			this.barItemAlignTextLeft.CategoryIndex = 6;
			this.barItemAlignTextLeft.ID = "Align Text Left";
			this.barItemAlignTextLeft.ImageIndex = 52;
			this.barItemAlignTextLeft.ImageList = this.smBarItemImages;
			this.barItemAlignTextLeft.Text = "Align Text Left";
			this.barItemAlignTextLeft.Tooltip = "Align Text Left";
			this.barItemAlignTextLeft.Click += new System.EventHandler(this.barItemAlignTextLeft_Click);
			// 
			// barItemCenterText
			// 
			this.barItemCenterText.CategoryIndex = 6;
			this.barItemCenterText.ID = "Center Text";
			this.barItemCenterText.ImageIndex = 53;
			this.barItemCenterText.ImageList = this.smBarItemImages;
			this.barItemCenterText.Text = "Center Text";
			this.barItemCenterText.Tooltip = "Center Text";
			this.barItemCenterText.Click += new System.EventHandler(this.barItemCenterText_Click);
			// 
			// barItemAlignTextRight
			// 
			this.barItemAlignTextRight.CategoryIndex = 6;
			this.barItemAlignTextRight.ID = "Align Text Right";
			this.barItemAlignTextRight.ImageIndex = 54;
			this.barItemAlignTextRight.ImageList = this.smBarItemImages;
			this.barItemAlignTextRight.Text = "Align Text Right";
			this.barItemAlignTextRight.Tooltip = "Align Text Right";
			this.barItemAlignTextRight.Click += new System.EventHandler(this.barItemAlignTextRight_Click);
			// 
			// barItemTextColor
			// 
			this.barItemTextColor.CategoryIndex = 6;
			this.barItemTextColor.ID = "Text Color";
			this.barItemTextColor.ImageIndex = 55;
			this.barItemTextColor.ImageList = this.smBarItemImages;
			this.barItemTextColor.Text = "Text Color";
			this.barItemTextColor.Tooltip = "Text Color";
			this.barItemTextColor.Click += new System.EventHandler(this.barItemTextColor_Click);
			// 
			// bar3
			// 
			this.bar3.BarName = "Scripting";
			this.bar3.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																							  this.barItemLoadScript,
																							  this.barItemRunScript,
																							  this.barItemEditScript,
																							  this.barItemStopScript});
			this.bar3.Manager = this.childFrameBarManager;
			// 
			// barItemLoadScript
			// 
			this.barItemLoadScript.CategoryIndex = 7;
			this.barItemLoadScript.ID = "Load Script";
			this.barItemLoadScript.ImageIndex = 56;
			this.barItemLoadScript.ImageList = this.smBarItemImages;
			this.barItemLoadScript.Text = "Load Script";
			this.barItemLoadScript.Tooltip = "Load Script";
			this.barItemLoadScript.Click += new System.EventHandler(this.barItemLoadScript_Click);
			// 
			// barItemRunScript
			// 
			this.barItemRunScript.CategoryIndex = 7;
			this.barItemRunScript.ID = "Run Script";
			this.barItemRunScript.ImageIndex = 57;
			this.barItemRunScript.ImageList = this.smBarItemImages;
			this.barItemRunScript.Shortcut = System.Windows.Forms.Shortcut.F5;
			this.barItemRunScript.Text = "Run Script";
			this.barItemRunScript.Tooltip = "Run Script";
			this.barItemRunScript.Click += new System.EventHandler(this.barItemRunScript_Click);
			// 
			// barItemEditScript
			// 
			this.barItemEditScript.CategoryIndex = 7;
			this.barItemEditScript.ID = "Edit Script";
			this.barItemEditScript.ImageIndex = 58;
			this.barItemEditScript.ImageList = this.smBarItemImages;
			this.barItemEditScript.Text = "Edit Script";
			this.barItemEditScript.Tooltip = "Edit Script";
			this.barItemEditScript.Click += new System.EventHandler(this.barItemEditScript_Click);
			// 
			// barItemStopScript
			// 
			this.barItemStopScript.CategoryIndex = 7;
			this.barItemStopScript.ID = "Stop Script";
			this.barItemStopScript.ImageIndex = 59;
			this.barItemStopScript.ImageList = this.smBarItemImages;
			this.barItemStopScript.Shortcut = System.Windows.Forms.Shortcut.CtrlF5;
			this.barItemStopScript.Text = "Stop Script";
			this.barItemStopScript.Tooltip = "Stop Script";
			this.barItemStopScript.Click += new System.EventHandler(this.barItemStopScript_Click);
			// 
			// DiagramForm
			// 
			this.AllowDrop = true;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(520, 406);
			this.Controls.Add(this.diagramComponent);
			this.Name = "DiagramForm";
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Show;
			this.Text = "Diagram";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.DiagramForm_Closing);
			this.Load += new System.EventHandler(this.DiagramForm_Load);
			((System.ComponentModel.ISupportInitialize)(this.diagramComponent.Model)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.childFrameBarManager)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		protected Link CreateLink(PointF[] pts)
		{
			Link link = new Link(pts);
			//link.EndPoints.LastEndPoint = new FilledArrowDecorator();
			return link;
		}

		protected Link CreateDirectedLink(PointF[] pts)
		{
			Link link = new Link(pts);
			EndPointDecoratorModel decoratorMdl = Global.EndPointDecoratorPalette["Filled Arrow"];
			if (decoratorMdl != null)
			{
				link.EndPoints.LastEndPointDecorator = decoratorMdl.CreateInstance();
			}
			return link;
		}

		protected Link CreateOrthogonalLink(PointF[] pts)
		{
			Link link = new Link(Link.Shapes.OrthogonalLine, pts);
			return link;
		}

		protected Link CreateDirectedOrthogonalLink(PointF[] pts)
		{
			Link link = new Link(Link.Shapes.OrthogonalLine, pts);
			EndPointDecoratorModel decoratorMdl = Global.EndPointDecoratorPalette["Filled Arrow"];
			if (decoratorMdl != null)
			{
				link.EndPoints.LastEndPointDecorator = decoratorMdl.CreateInstance();
			}
			return link;
		}

		protected Link CreateArcLink(PointF[] pts)
		{
			Link link = new Link(Link.Shapes.Arc, pts);
			return link;
		}

		private void UpdateMagnificationComboBox()
		{
			System.Drawing.Size szMag = this.diagramComponent.View.Magnification;
			this.comboBoxBarItemMagnification.TextBoxValue = szMag.Width + "%";
		}

		private void toolActivate(object sender, System.EventArgs e)
		{
			Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem = sender as Syncfusion.Windows.Forms.Tools.XPMenus.BarItem;

			if (barItem != null)
			{
				string toolName = (string) barItem.Tag;
				Tool tool = this.diagramComponent.Controller.GetTool(toolName);
				if (tool != null)
				{
					if (tool.Active)
					{
						this.diagramComponent.Controller.DeactivateTool(tool);
					}
					else
					{
						this.diagramComponent.Controller.ActivateTool(tool);
					}
				}
			}
		}

		protected void OnDiagramToolActivate(object sender, Controller.ToolEventArgs evtArgs)
		{
			//this.CheckTool(evtArgs.Tool.Name);
		}

		protected void OnDiagramToolDeactivate(object sender, Controller.ToolEventArgs evtArgs)
		{
			//this.UncheckTool(evtArgs.Tool.Name);
		}

		protected void OnSelectionChanged(object sender, NodeCollectionEventArgs evtArgs)
		{
			this.UpdateUITextFormatting();
		}

		private void barItemLinkSymbols_Click(object sender, System.EventArgs e)
		{
			Tool linkTool = this.diagramComponent.Controller.GetTool("LinkTool");
			if (linkTool != null)
			{
				this.diagramComponent.Controller.ActivateTool(linkTool);
			}
		}

		private void barItemShowGrid_Click(object sender, System.EventArgs e)
		{
			this.barItemShowGrid.Checked = !this.barItemShowGrid.Checked;
			this.diagramComponent.View.Grid.Visible = this.barItemShowGrid.Checked;
		}

		private void barItemSnapToGrid_Click(object sender, System.EventArgs e)
		{
			this.barItemSnapToGrid.Checked = !this.barItemSnapToGrid.Checked;
			this.diagramComponent.View.Grid.SnapToGrid = this.barItemSnapToGrid.Checked;
		}

		private void DiagramForm_Load(object sender, System.EventArgs e)
		{
			this.barItemShowGrid.Checked = this.diagramComponent.View.Grid.Visible;
			this.barItemSnapToGrid.Checked = this.diagramComponent.View.Grid.SnapToGrid;
			UpdateMagnificationComboBox();

			// Attach link factory to the default link tool
			Tool linkTool = this.diagramComponent.Controller.GetTool("LinkTool");
			if (linkTool != null && linkTool.GetType() == typeof(LinkTool))
			{
				((LinkTool)linkTool).LinkFactory = new LinkFactory(this.CreateLink);
			}

			// Create and register a tool for orthogonal links
			LinkTool orthogonalLinkTool = new LinkTool("OrthogonalLinkTool");
			orthogonalLinkTool.LinkFactory = new LinkFactory(this.CreateOrthogonalLink);
			this.diagramComponent.Controller.RegisterTool(orthogonalLinkTool);

			// Create and register a tool for directed links
			LinkTool directedLinkTool = new LinkTool("DirectedLinkTool");
			directedLinkTool.LinkFactory = new LinkFactory(this.CreateDirectedLink);
			this.diagramComponent.Controller.RegisterTool(directedLinkTool);

			// Create and register a tool for arc links
			LinkTool arcLinkTool = new LinkTool("ArcLinkTool");
			arcLinkTool.LinkFactory = new LinkFactory(this.CreateArcLink);
			this.diagramComponent.Controller.RegisterTool(arcLinkTool);

			// Set focus to the diagram control
			this.diagramComponent.Focus();
		}

		private void comboBoxBarItemMagnification_Click(object sender, System.EventArgs e)
		{
			string strMagValue = this.comboBoxBarItemMagnification.TextBoxValue;
			int idxPctSign = strMagValue.IndexOf('%');
			if (idxPctSign >= 0)
			{
				strMagValue = strMagValue.Remove(idxPctSign, 1);
			}
			int magVal = System.Convert.ToInt32(strMagValue);
			this.diagramComponent.View.Magnification = new System.Drawing.Size(magVal, magVal);
			this.diagramComponent.Refresh();
		}

		private void diagramComponent_View_MagnificationChanged(object sender, ViewMagnificationEventArgs evtArgs)
		{
			UpdateMagnificationComboBox();
		}

		private void barItemBringToFront_Click(object sender, System.EventArgs e)
		{
			this.diagramComponent.Controller.BringToFront();
		}

		private void barItemSendToBack_Click(object sender, System.EventArgs e)
		{
			this.diagramComponent.Controller.SendToBack();
		}

		private void barItemBringForward_Click(object sender, System.EventArgs e)
		{
			this.diagramComponent.Controller.BringForward();
		}

		private void barItemSendBackward_Click(object sender, System.EventArgs e)
		{
			this.diagramComponent.Controller.SendBackward();
		}

		private void barItemNudgeUp_Click(object sender, System.EventArgs e)
		{
			this.diagramComponent.NudgeUp();
		}

		private void barItemNudgeDown_Click(object sender, System.EventArgs e)
		{
			this.diagramComponent.NudgeDown();
		}

		private void barItemNudgeLeft_Click(object sender, System.EventArgs e)
		{
			this.diagramComponent.NudgeLeft();
		}

		private void barItemNudgeRight_Click(object sender, System.EventArgs e)
		{
			this.diagramComponent.NudgeRight();
		}

		private void barItemRotateLeft_Click(object sender, System.EventArgs e)
		{
			this.diagramComponent.Rotate(-90);
		}

		private void barItemRotateRight_Click(object sender, System.EventArgs e)
		{
			this.diagramComponent.Rotate(90);
		}

		private void barItemFlipVertical_Click(object sender, System.EventArgs e)
		{
			this.diagramComponent.FlipVertical();
		}

		private void barItemFlipHorizontal_Click(object sender, System.EventArgs e)
		{
			this.diagramComponent.FlipHorizontal();
		}

		private void barItemImage_Click(object sender, System.EventArgs e)
		{
			this.diagramComponent.InsertImage();
		}

		private void DiagramForm_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			Syncfusion.Windows.Forms.Diagram.Controls.PropertyEditor propEditor = this.PropertyEditor;
			if (propEditor != null)
			{
				propEditor.Diagram = null;
			}
		}

		private void barItemOrthogonalLink_Click(object sender, System.EventArgs e)
		{
			this.diagramComponent.ActivateTool("OrthogonalLinkTool");
		}

		private void barItemDirectedLink_Click(object sender, System.EventArgs e)
		{
			this.diagramComponent.ActivateTool("DirectedLinkTool");
		}

		private void barItemArcLink_Click(object sender, System.EventArgs e)
		{
			this.diagramComponent.ActivateTool("ArcLinkTool");
		}

		private void LoadFontSelections()
		{
			// Create ListBox containing names of font families and attach it to the
			// font family combo box bar item
			this.comboBoxBarItemFontFamily.ListBox = new ListBox();
			foreach (FontFamily curFontFamily in System.Drawing.FontFamily.Families)
			{
				this.comboBoxBarItemFontFamily.ListBox.Items.Add(curFontFamily.Name);
			}
			this.comboBoxBarItemFontFamily.ListBox.SelectedIndexChanged += new System.EventHandler(this.FontFamily_SelectedIndexChanged);

			// Create ListBox containing point sizes and attach to the point size combo
			// box bar item
			ListBox pointSizeListBox = new ListBox();
			int[] ptSizes = new int[] { 8, 9, 10, 11, 12, 14, 16, 18, 20, 22, 24, 26, 28, 36, 48, 72 };
			foreach (int ptSize in ptSizes)
			{
				pointSizeListBox.Items.Add(ptSize);
			}
			this.comboBoxBarItemPointSize.ListBox = pointSizeListBox;
			this.comboBoxBarItemPointSize.ListBox.SelectedIndexChanged += new System.EventHandler(this.PointSize_SelectedIndexChanged);
		}

		private void FontFamily_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			int selectedIdx = this.comboBoxBarItemFontFamily.ListBox.SelectedIndex;
			if (selectedIdx >= 0)
			{
				string fontFamily = (string) this.comboBoxBarItemFontFamily.ListBox.Items[selectedIdx];
				this.diagramComponent.Controller.TextFormatter.FontFamily = fontFamily;
			}
		}

		private void PointSize_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			int selectedIdx = this.comboBoxBarItemPointSize.ListBox.SelectedIndex;
			if (selectedIdx >= 0)
			{
				int ptSize = (int) this.comboBoxBarItemPointSize.ListBox.Items[selectedIdx];
				this.diagramComponent.Controller.TextFormatter.PointSize = (float) ptSize;
			}
		}

		private void UpdateUITextFormatting()
		{
			Syncfusion.Windows.Forms.Diagram.Controller controller = this.diagramComponent.Controller;

			// Update font family bar item
			string fontFamily = controller.TextFormatter.FontFamily;
			if (fontFamily != null && fontFamily.Length > 0)
			{
				bool found = false;

				for (int itemIdx = 0; !found && itemIdx < this.comboBoxBarItemFontFamily.ListBox.Items.Count; itemIdx++)
				{
					string curFontFamilyName = (string) this.comboBoxBarItemFontFamily.ListBox.Items[itemIdx];
					if (curFontFamilyName == fontFamily)
					{
						this.comboBoxBarItemFontFamily.ListBox.SelectedIndex = itemIdx;
						this.comboBoxBarItemFontFamily.TextBoxValue = fontFamily;
						found = true;
					}
				}
			}

			// Update Bold, Italic, and Underline bar items
			this.barItemBoldText.Checked = controller.TextFormatter.Bold;
			this.barItemItalicText.Checked = controller.TextFormatter.Italic;
			this.barItemUnderlineText.Checked = controller.TextFormatter.Underline;

			// Update point size bar item
			float ptSize = controller.TextFormatter.PointSize;
			this.comboBoxBarItemPointSize.TextBoxValue = ptSize.ToString();

			// Update text alignment bar items
			StringAlignment horzAlign = controller.TextFormatter.HorizontalAlignment;
			if (horzAlign == StringAlignment.Near)
			{
				this.barItemAlignTextLeft.Checked = true;
				this.barItemCenterText.Checked = false;
				this.barItemAlignTextRight.Checked = false;
			}
			else if (horzAlign == StringAlignment.Center)
			{
				this.barItemAlignTextLeft.Checked = false;
				this.barItemCenterText.Checked = true;
				this.barItemAlignTextRight.Checked = false;
			}
			else if (horzAlign == StringAlignment.Far)
			{
				this.barItemAlignTextLeft.Checked = false;
				this.barItemCenterText.Checked = false;
				this.barItemAlignTextRight.Checked = true;
			}
		}

		private void barItemBoldText_Click(object sender, System.EventArgs e)
		{
			bool newValue = !(this.diagramComponent.Controller.TextFormatter.Bold);
			this.diagramComponent.Controller.TextFormatter.Bold = newValue;
			this.barItemBoldText.Checked = newValue;
		}

		private void barItemItalicText_Click(object sender, System.EventArgs e)
		{
			bool newValue = !(this.diagramComponent.Controller.TextFormatter.Italic);
			this.diagramComponent.Controller.TextFormatter.Italic = newValue;
			this.barItemItalicText.Checked = newValue;
		}

		private void barItemUnderlineText_Click(object sender, System.EventArgs e)
		{
			bool newValue = !(this.diagramComponent.Controller.TextFormatter.Underline);
			this.diagramComponent.Controller.TextFormatter.Underline = newValue;
			this.barItemUnderlineText.Checked = newValue;
		}

		private void barItemTextColor_Click(object sender, System.EventArgs e)
		{
			ColorDialog dlg = new ColorDialog();
			dlg.Color = this.diagramComponent.Controller.TextFormatter.TextColor;
			if (dlg.ShowDialog(this) == DialogResult.OK)
			{
				this.diagramComponent.Controller.TextFormatter.TextColor = dlg.Color;
			}
		}

		private void barItemAlignTextLeft_Click(object sender, System.EventArgs e)
		{
			this.diagramComponent.Controller.TextFormatter.HorizontalAlignment = StringAlignment.Near;
			this.barItemAlignTextLeft.Checked = true;
			this.barItemCenterText.Checked = false;
			this.barItemAlignTextRight.Checked = false;
		}

		private void barItemCenterText_Click(object sender, System.EventArgs e)
		{
			this.diagramComponent.Controller.TextFormatter.HorizontalAlignment = StringAlignment.Center;
			this.barItemCenterText.Checked = true;
			this.barItemAlignTextLeft.Checked = false;
			this.barItemAlignTextRight.Checked = false;
		}

		private void barItemAlignTextRight_Click(object sender, System.EventArgs e)
		{
			this.diagramComponent.Controller.TextFormatter.HorizontalAlignment = StringAlignment.Far;
			this.barItemAlignTextRight.Checked = true;
			this.barItemAlignTextLeft.Checked = false;
			this.barItemCenterText.Checked = false;
		}

		protected override void OnLoad(EventArgs e)
		{
			base.OnLoad(e);
			this.diagramComponent.LoadScript("..\\..\\_TESTSCRIPT\\testscript.vb");		
		}

		private void barItemLoadScript_Click(object sender, System.EventArgs e)
		{			
			System.Windows.Forms.OpenFileDialog fileDlg = new System.Windows.Forms.OpenFileDialog();

			if(fileDlg.ShowDialog(this) == DialogResult.OK)
			{
				string sourceFile = fileDlg.FileName;
				this.diagramComponent.LoadScript(sourceFile);
			}
		}

		private void barItemRunScript_Click(object sender, System.EventArgs e)
		{
			bool compiled = false;

			if (this.diagramComponent.NeedToCompileScript)
			{
				if(this.diagramComponent.ScriptingManager.ApplicationBase == String.Empty)
					this.diagramComponent.ScriptingManager.ApplicationBase = new DirectoryInfo(GetAssembliesPath()).FullName;
				compiled = this.diagramComponent.CompileScript();
			}
			else
			{
				compiled = true;
			}

			if (compiled)
			{
				this.diagramComponent.RunScript();
			}
		}
		
		private void barItemEditScript_Click(object sender, System.EventArgs e)
		{
			// Create the ScriptEditControl and initialize it with the diagram's ScriptingManager instance
			Syncfusion.Scripting.Design.ScriptEditForm scripteditform = new Syncfusion.Scripting.Design.ScriptEditForm();				
			ScriptEditControl scriptedit = scripteditform.ScriptEditControl;
			scriptedit.InitializeScriptEditor(this.diagramComponent.ScriptingManager);
			// Disable external compilation
			scriptedit.EnableExternalCompile = true;
			// Show the ScriptEditForm as a modal dialog
			scripteditform.ShowDialog(this);
			scripteditform.Dispose();
		}

		private void barItemStopScript_Click(object sender, System.EventArgs e)
		{
			if (this.diagramComponent.IsScriptRunning)
			{
				this.diagramComponent.ResetScriptEngine();
			}
		}

		private void scripteEditControl_CompileScript(object sender, EventArgs evtArgs)
		{
			this.diagramComponent.ScriptingManager.ApplicationBase = new DirectoryInfo(GetAssembliesPath()).FullName;
			this.diagramComponent.CompileScript();
		}

		static string GetAssembliesPath()
		{			
			string assembliesfolder = GetNETVersion();
			int i = 1;
			string returnPath = string.Empty;
			while(i < 15)
			{
				string pathBase = new string('%', i);
				pathBase = pathBase.Replace("%", "..\\");
				if(Directory.Exists(pathBase + "Essential Studio"))
				{
					returnPath = pathBase + "Essential Studio" + "\\" + "Assemblies" + "\\" + assembliesfolder;
					if(Directory.Exists(returnPath) == false)
						returnPath = string.Empty;
					break;

				}
				i++;
			}
			return returnPath;
		}

		static string GetNETVersion()
		{
			Assembly[] assemblies = AppDomain.CurrentDomain.GetAssemblies();
			foreach(Assembly assmbly in assemblies)
			{
				string location = assmbly.Location;
				if(location.IndexOf("mscorlib.dll") >= 0)
				{
					if(location.IndexOf("v1.0") >= 0)
						return "1.0";
					else if(location.IndexOf("v1.1") >= 0)
						return "1.1";
					else return "2.0";
				}
			}
			return "1.1";
		}

		private void diagramComponent_CompileError(object sender, VsaErrorEventArgs evtArgs)
		{
			//MessageBox.Show(this, "Error compiling script: " + evtArgs.Error.Description);
		}		
		
	}
}
