#region Copyright Syncfusion Inc. 2001 -2005
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
//  Copyright Syncfusion Inc. All rights reserved. Use of this code is subject to the terms of our 
//  license. A copy of the current license can be obtained at any time by e-mailing licensing@syncfusion.com. 
//  Re-distribution in any form is strictly prohibited. Any infringement will be prosecuted under applicable laws. 
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
#endregion 
 
using System;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Diagram;

namespace Syncfusion
{
public class Script
{  
  public static void Main()
  {
  MessageBox.Show("Starting CSharp Script", "Essential Suite Scripting", MessageBoxButtons.OK, MessageBoxIcon.Information);
  }
  
  public static void OnScriptStart()
  {
  Syncfusion.Global.Model.DoubleClick += new NodeMouseEventHandler(Script.Model_DoubleClick);
  Syncfusion.Global.Model.ChildrenChangeComplete += new NodeCollectionEventHandler(Script.Model_ChildrenChangeComplete);
  }
  
  public static void OnScriptStop()
  {
  Syncfusion.Global.Model.DoubleClick -= new NodeMouseEventHandler(Script.Model_DoubleClick);
  Syncfusion.Global.Model.ChildrenChangeComplete -= new NodeCollectionEventHandler(Script.Model_ChildrenChangeComplete);
  }
  
  public static void Model_DoubleClick( object sender, NodeMouseEventArgs args)
  {
	  if(args.Node is Syncfusion.Windows.Forms.Diagram.Shape)
	  {
		  Syncfusion.Windows.Forms.Diagram.Shape shapenode = args.Node as Shape;
		  System.Drawing.Color fillcolor = (System.Drawing.Color)shapenode.GetPropertyValue("FillColor");
		  if(fillcolor == System.Drawing.Color.Red)
		  	shapenode.SetPropertyValue("FillColor", System.Drawing.Color.Green);
		  else if(fillcolor == System.Drawing.Color.Green)
		    shapenode.SetPropertyValue("FillColor", System.Drawing.Color.Blue);
		  else shapenode.SetPropertyValue("FillColor", System.Drawing.Color.Red);
		  // Notify Model to update the View
		  (sender as Syncfusion.Windows.Forms.Diagram.Model).UpdateViews();
	  }	  
  }
  
  public static void Model_ChildrenChangeComplete( object sender, NodeCollectionEventArgs args)
  {
	  if(args.Node is Syncfusion.Windows.Forms.Diagram.FilledShape)
	  {
		  Syncfusion.Windows.Forms.Diagram.FilledShape fillednode = args.Node as FilledShape;
		  fillednode.SetPropertyValue("FillColor", System.Drawing.Color.Red);
	  }
	  
	  if(args.ChangeType == Syncfusion.Windows.Forms.Diagram.CollectionExChangeType.Insert)
            MessageBox.Show(String.Concat(args.Node.Name, " node added"), "Essential Suite Scripting", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
      else if(args.ChangeType == Syncfusion.Windows.Forms.Diagram.CollectionExChangeType.Remove)
            MessageBox.Show(String.Concat(args.Node.Name, " node Removed"), "Essential Suite Scripting", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
  }
}
}
