import System.Drawing;
import System.Windows.Forms;
import Syncfusion.Windows.Forms.Diagram;

class Script{ 
  
  static function Main()
  {
    MessageBox.Show("Starting JScript script", "Essential Suite Scripting", MessageBoxButtons.OK, MessageBoxIcon.Information)
  }
  
  static function OnScriptStart()
  {
    Model.add_DoubleClick(Script.Model_DoubleClick)
    Model.add_ChildrenChangeComplete(Script.Model_ChildrenChangeComplete)
  }
  
  static function OnScriptStop()
  {
    Model.remove_DoubleClick(Script.Model_DoubleClick)
    Model.remove_ChildrenChangeComplete(Script.Model_ChildrenChangeComplete)
  }
  
  static function Model_DoubleClick(sender: Object,  args:NodeMouseEventArgs)
  {  
    if((args.Node != null) && (args.Node instanceof Syncfusion.Windows.Forms.Diagram.FilledShape))
    {      
        var shapenode:FilledShape = FilledShape(args.Node);       
        var colorval:Color = shapenode.GetPropertyValue("FillColor");      
        var strcolor = colorval.ToString();
        if(strcolor == Color.Red.ToString())
            shapenode.SetPropertyValue("FillColor", Color.Green);
        else if(strcolor == Color.Green.ToString())
            shapenode.SetPropertyValue("FillColor", Color.Blue);
        else 
            shapenode.SetPropertyValue("FillColor", Color.Red);
        
        var diagrammodel = sender;
        Syncfusion.Windows.Forms.Diagram.Model(diagrammodel).UpdateViews();                            
    }
  }
  
  static function Model_ChildrenChangeComplete(sender:Object,  args:NodeCollectionEventArgs)
  {   
    if(args.Node != null)
    {        
        if(args.Node instanceof Syncfusion.Windows.Forms.Diagram.FilledShape)
        {
            var shapenode:FilledShape = FilledShape(args.Node);
            shapenode.SetPropertyValue("FillColor", Color.Red)        
        }
        
        if(args.ChangeType == Syncfusion.Windows.Forms.Diagram.CollectionExChangeType.Insert)
        {
            MessageBox.Show(String.Concat(args.Node.Name, " node added"), "Essential Suite Scripting", 
            MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
        }
        else if(args.ChangeType == Syncfusion.Windows.Forms.Diagram.CollectionExChangeType.Remove)
        {
            MessageBox.Show(String.Concat(args.Node.Name, " node Removed"), "Essential Suite Scripting", 
            MessageBoxButtons.OK, MessageBoxIcon.Exclamation);     
        }
    }  
  }  
}


