Imports System
Imports System.Drawing
Imports System.Windows.Forms
Imports Syncfusion.Windows.Forms.Diagram

module Script  
  
  Public Sub Main()
  MessageBox.Show("Starting VisualBasic Script", "Essential Suite Scripting", MessageBoxButtons.OK, MessageBoxIcon.Information)
  End Sub
  
  Public Sub Model_DoubleClick( sender As Object, e As NodeMouseEventArgs) Handles Model.DoubleClick
        If TypeOf e.Node Is Shape Then
            Dim shapenode As Shape = CType(e.Node, Shape)
            Dim fillcolor As System.Drawing.Color = CType(shapenode.GetPropertyValue("FillColor"), System.Drawing.Color)
            Dim colorvalue As String = fillcolor.ToString()
            If colorvalue = Color.Red.ToString() Then
                shapenode.SetPropertyValue("FillColor", Color.Green)
            ElseIf colorvalue = Color.Green.ToString() Then
                shapenode.SetPropertyValue("FillColor", Color.Blue)
            Else
                shapenode.SetPropertyValue("FillColor", Color.Red)
            End If
            
            Dim diagrammodel As Model = CType(sender, Model)
            diagrammodel.UpdateViews()
        End If
  End Sub
  
  Public Sub Model_ChildrenChangeComplete( sender As Object, e As NodeCollectionEventArgs) Handles Model.ChildrenChangeComplete
  
       If TypeOf e.Node Is FilledShape Then
            Dim fillednode As FilledShape = CType(e.Node, FilledShape)
            fillednode.SetPropertyValue("FillColor", Color.Red)
        End If
  
        If e.ChangeType = Syncfusion.Windows.Forms.Diagram.CollectionExChangeType.Insert Then
            MessageBox.Show(String.Concat(e.Node.Name, " node added"), "Essential Suite Scripting", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        ElseIf e.ChangeType = Syncfusion.Windows.Forms.Diagram.CollectionExChangeType.Remove Then
            MessageBox.Show(String.Concat(e.Node.Name, " node Removed"), "Essential Suite Scripting", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
    End If
    
  End Sub
end module